#pragma once

#include "CoreMinimal.h"
#include "Components/ActorComponent.h"
#include "UObject/NoExportTypes.h"
#include "DBDTunableRowHandle.h"
#include "InvitationTargetComponent.generated.h"

class AActor;

UCLASS(Blueprintable, Abstract, meta=(BlueprintSpawnableComponent))
class ANNIVERSARY_API UInvitationTargetComponent : public UActorComponent
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	float _interactionAngleInDegrees;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FLinearColor _revealColor;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _abilityTargetMaxHeightDifference;

protected:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_OnTargetObjectChanged(AActor* target, AActor* lastTarget);

public:
	UInvitationTargetComponent();
};

FORCEINLINE uint32 GetTypeHash(const UInvitationTargetComponent) { return 0; }
